using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Categories;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IProductTypeRepository
    {
        Task<BaseResult> Add(ProductTypeElastic ProductType);
        Task<BaseResult> AddManyAsync(IEnumerable<ProductTypeElastic> ProductTypes);
        Task<SmartTableResult<ProductTypeElastic>> Search(BoolQueryDescriptor<ProductTypeElastic> query);
        Task<SmartTableResult<ProductTypeElastic>> GetByIds(List<long> ids);
        Task<SmartTableResult<ProductTypeElastic>> GetAll();

    }
    public class ProductTypeRepository : IProductTypeRepository
    {
        private readonly ElasticIndex<ProductTypeElastic> _dbContext;

        public ProductTypeRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<ProductTypeElastic>(settings.Value.ClusterUrl, "inventoryproducttype");
        }


        public async Task<SmartTableResult<ProductTypeElastic>> Search(BoolQueryDescriptor<ProductTypeElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(ProductTypeElastic ProductType)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(ProductType);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<ProductTypeElastic> ProductTypes)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(ProductTypes);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<ProductTypeElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<ProductTypeElastic>();
            var idsQ = new QueryContainerDescriptor<ProductTypeElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }
        public async Task<SmartTableResult<ProductTypeElastic>> GetAll()
        {
            var query = new BoolQueryDescriptor<ProductTypeElastic>();
            var isdeletedQ  = new QueryContainerDescriptor<ProductTypeElastic>();
            isdeletedQ.Terms(t => t.Field(f => f.IsDeleted).Terms(false));
            query.Filter(f => isdeletedQ);
            return await _dbContext.Search(query);
        }
    }
}
